<template>
    <v-table class="v-table">
        <thead>
            <tr>
                <th v-for="(header, index) in headers" :key="index" class="text-left">{{ header }}</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="(row, index) in pagedData" :key="index"
                :style="{ backgroundColor: index % 2 == 0 ? '#EFF7FF' : 'white' }">
                <td v-for="(column, ind) in row" :key="ind">
                    <div v-if="column != 'up' && column != 'down'">{{ column }}</div>
                    <div v-if="column == 'up' || column == 'down' && this.showButton">

                        <custom-button style="width: 120px;margin-left: 10px" color="table-btn" size="medium"
                            :arrow="column" @click="this.handleClick(row,row.Id)" :val="showButtonName" :id="row.Id" />
                    </div>
                </td>
            </tr>
        </tbody>
    </v-table>

    <div class="pagination">
        <button class="button" :disabled="currentPage === 1" @click="currentPage = 1"> <v-icon
                icon="mdi-chevron-left">mdi-chevron-double-left</v-icon></button>

        <button v-if="this.width >= 1024" class="button" :disabled="currentPage === 1" @click="currentPage--">
            <v-icon icon="mdi-chevron-left">mdi-chevron-left</v-icon>
        </button>

        <button style="border-radius: 9px !important;" v-for="page in displayedPages" :key="page"
            :class="{ active: currentPage === page }" @click="currentPage = page"
            :style="{ backgroundColor: currentPage === page ? '#00468A' : '#EFF7FF', color: currentPage === page ? 'white' : '#00468A' }">{{
                page }}</button>

        <button v-if="this.width >= 1024" class="button" :disabled="currentPage === pageCount" @click="currentPage++">
            <v-icon icon="mdi-chevron-left">mdi-chevron-right</v-icon>
        </button>

        <button class="button" :disabled="currentPage === pageCount" @click="currentPage = pageCount">
            <v-icon icon="mdi-chevron-left">mdi-chevron-double-right</v-icon>
        </button>
    </div>
    <CustomTableModal :isOpen="isModalOpen" @close="closeModal" />
</template>

<script>
import { defineComponent, ref, computed, onMounted, onUnmounted } from 'vue';
import CustomButton from './CustomButton.vue';
import eventBus from '@/plugins/eventBus';
import CustomTableModal from './CustomTableModal.vue';
export default defineComponent({
    components: {
        CustomButton,
        CustomTableModal
    },
    props: {
        data: {
            type: Array,
            required: true,
        },
        headers: {
            type: Array,
            required: true,
        },
        pageSize: {
            type: Number,
            required: true,
        },
        pageDisplayCount: {
            type: Number,
            default: 3,
        },
        showButton: {
            type: Boolean,
            required: false,
        },
        showButtonName: {
            type: String,
        },
    },
    setup(props) {
        const isModalOpen = ref(false);
        const currentPage = ref(1);
        const width = ref(window.innerWidth);
        const updateWindowDimensions = () => {
            width.value = window.innerWidth;
        };
        const newEntry = () => {
            isModalOpen.value = ref(true);
        }
        const closeModal = () => {
            isModalOpen.value = ref(false);
        }

        onMounted(() => {
            window.addEventListener('resize', updateWindowDimensions);
        });

        onUnmounted(() => {
            window.removeEventListener('resize', updateWindowDimensions);
        });

        const pageCount = computed(() => {
            return Math.ceil(props.data.length / props.pageSize);
        });

        const pages = computed(() => {
            const pages = [];
            for (let i = 1; i <= pageCount.value; i++) {
                pages.push(i);
            }
            return pages;
        });

        const pagedData = computed(() => {
            const start = (currentPage.value - 1) * props.pageSize;
            const end = start + props.pageSize;
            return props.data.slice(start, end);
        });

        const displayedPages = computed(() => {
            const pages = [];
            const left = Math.max(1, currentPage.value - Math.floor(width.value <= 1024 ? 3 : props.pageDisplayCount / 2));
            const right = Math.min(pageCount.value, left + width.value <= 1024 ? 3 : props.pageDisplayCount - 1);
            for (let i = left; i <= right; i++) {
                pages.push(i);
            }
            return pages;
        });

        const handleClick = (event, id) => {
            var element = document.getElementById(id);
            newEntry();
            if (element.classList.contains("mdi-chevron-up")) {
                element.classList.remove("mdi-chevron-up");
                element.classList.add("mdi-chevron-down");
            } else if (element.classList.contains("mdi-chevron-down")) {
                element.classList.remove("mdi-chevron-down");
                element.classList.add("mdi-chevron-up");
            }
            eventBus.emit('table-btn', event);
        }

        return {
            currentPage,
            width,
            pageCount,
            pages,
            pagedData,
            displayedPages,
            handleClick,
            closeModal,
            newEntry
        };
    },
});
</script>

<style scoped>
.v-table {
    width: 100%;
    border-collapse: collapse;
    border: 1px solid #004FA3;
    border-radius: 11px;
}

th,
td {
    padding: 8px;
    text-align: left;
}

th {
    background-color: #004FA3;
    color: white !important;
}


tr:nth-child(even) {
    background-color: #EFF7FF;
}

.pagination {
    margin-top: 16px;
    float: right;
}

button {
    margin-right: 8px;
    padding: 4px 8px;
    border-radius: 4px;
    border: none;
    background-color: #004FA3;
    color: white;
    cursor: pointer;
}

.button {
    background-color: transparent;
    color: #004FA3;
}

button:disabled {
    opacity: 0.5;
    cursor: not-allowed;
}

.active {
    background-color: #004FA3;
}
</style>
  